import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { WbRegisterEvent } from '../models/index' 
/**
 * @author auto generate
 * @version 1.2
 * @date 2020-12-29 15:31
 */
interface WbRegisterEventCU extends ConditionUtil<WbRegisterEventCU>{
    ID:FieldUtil<WbRegisterEventCU>;
    OUTER_USER_ID:FieldUtil<WbRegisterEventCU>;
    USER_ACTION:FieldUtil<WbRegisterEventCU>;
    ACTION_TIME:FieldUtil<WbRegisterEventCU>;
    OUTER_DATA:FieldUtil<WbRegisterEventCU>;
    CREATE_TIME:FieldUtil<WbRegisterEventCU>;
    UPDATE_TIME:FieldUtil<WbRegisterEventCU>;
}

class WbRegisterEventCUImpl extends ConditionUtilImpl<WbRegisterEventCUImpl> implements WbRegisterEventCU{ 
    newInstance(): WbRegisterEventCUImpl {
        return new WbRegisterEventCUImpl();
    } 
    get ID(): FieldUtil<WbRegisterEventCU>{  
        return new FieldUtil('ID','id','', this);
    }
    get OUTER_USER_ID(): FieldUtil<WbRegisterEventCU>{  
        return new FieldUtil('OUTER_USER_ID','outerUserId','', this);
    }
    get USER_ACTION(): FieldUtil<WbRegisterEventCU>{  
        return new FieldUtil('USER_ACTION','userAction','', this);
    }
    get ACTION_TIME(): FieldUtil<WbRegisterEventCU>{  
        return new FieldUtil('ACTION_TIME','actionTime','', this);
    }
    get OUTER_DATA(): FieldUtil<WbRegisterEventCU>{  
        return new FieldUtil('OUTER_DATA','outerData','', this);
    }
    get CREATE_TIME(): FieldUtil<WbRegisterEventCU>{  
        return new FieldUtil('CREATE_TIME','createTime','创建时间', this);
    }
    get UPDATE_TIME(): FieldUtil<WbRegisterEventCU>{  
        return new FieldUtil('UPDATE_TIME','updateTime','更新时间', this);
    }
}

@Singleton 
class WbRegisterEventMU extends TableUtilImpl<WbRegisterEventCU,WbRegisterEvent>{ 
    tableName  = 'wb_register_event';
    tableFields  = ['ID','OUTER_USER_ID','USER_ACTION','ACTION_TIME','OUTER_DATA','CREATE_TIME','UPDATE_TIME'];
    modelFields  = ['id','outerUserId','userAction','actionTime','outerData','createTime','updateTime'];
    modelIdFields  = ['id'];
    tableIdFields  = ['ID'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [];

    createConditionUtil(): WbRegisterEventCU {
        return new WbRegisterEventCUImpl();
    }   

    static get ID(): FieldUtil<WbRegisterEventCU>{ 
        return new FieldUtil('ID','id','', new WbRegisterEventCUImpl());
    }
    static get OUTER_USER_ID(): FieldUtil<WbRegisterEventCU>{ 
        return new FieldUtil('OUTER_USER_ID','outerUserId','', new WbRegisterEventCUImpl());
    }
    static get USER_ACTION(): FieldUtil<WbRegisterEventCU>{ 
        return new FieldUtil('USER_ACTION','userAction','', new WbRegisterEventCUImpl());
    }
    static get ACTION_TIME(): FieldUtil<WbRegisterEventCU>{ 
        return new FieldUtil('ACTION_TIME','actionTime','', new WbRegisterEventCUImpl());
    }
    static get OUTER_DATA(): FieldUtil<WbRegisterEventCU>{ 
        return new FieldUtil('OUTER_DATA','outerData','', new WbRegisterEventCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<WbRegisterEventCU>{ 
        return new FieldUtil('CREATE_TIME','createTime','创建时间', new WbRegisterEventCUImpl());
    }
    static get UPDATE_TIME(): FieldUtil<WbRegisterEventCU>{ 
        return new FieldUtil('UPDATE_TIME','updateTime','更新时间', new WbRegisterEventCUImpl());
    }

    get ID(): FieldUtil<WbRegisterEventCU>{ 
        return WbRegisterEventMU.ID;
    }
    get OUTER_USER_ID(): FieldUtil<WbRegisterEventCU>{ 
        return WbRegisterEventMU.OUTER_USER_ID;
    }
    get USER_ACTION(): FieldUtil<WbRegisterEventCU>{ 
        return WbRegisterEventMU.USER_ACTION;
    }
    get ACTION_TIME(): FieldUtil<WbRegisterEventCU>{ 
        return WbRegisterEventMU.ACTION_TIME;
    }
    get OUTER_DATA(): FieldUtil<WbRegisterEventCU>{ 
        return WbRegisterEventMU.OUTER_DATA;
    }
    get CREATE_TIME(): FieldUtil<WbRegisterEventCU>{ 
        return WbRegisterEventMU.CREATE_TIME;
    }
    get UPDATE_TIME(): FieldUtil<WbRegisterEventCU>{ 
        return WbRegisterEventMU.UPDATE_TIME;
    }
}
export {WbRegisterEventMU, WbRegisterEventCU}
